--- swank-mit-scheme.scm	2011-01-21 09:15:05.000000000 +0100
+++ swank-mit-scheme-new.scm	2012-04-17 14:56:27.975213955 +0200
@@ -420,12 +420,19 @@
 (define (swank:operator-arglist socket name pack)
   (let ((v (ignore-errors
 	    (lambda ()
-	      (with-output-to-string 
-		(lambda ()
-		  (carefully-pa 
-		   (eval (read-from-string name) (user-env pack)))))))))
+              (strip-newline
+               (with-output-to-string 
+                 (lambda ()
+                   (carefully-pa 
+                    (eval (read-from-string name) (user-env pack))))))))))
     (if (condition? v) 'nil v)))
 
+(define (strip-newline s)
+  (let ((l (- (string-length s) 1)))
+    (if (eq? #\newline (string-ref s l))
+        (substring s 0 l)
+        s)))
+
 (define (carefully-pa o)
   (cond ((arity-dispatched-procedure? o) 
 	 ;; MIT Scheme crashes for (pa /)
